summaryrefslogtreecommitdiff
path: root/plugins/colorize
diff options
context:
space:
mode:
authorStephan Salzmann <kaffdaddy@insomniaonline.de>2018-10-19 19:27:49 +0200
committerMarc Cornellà <marc.cornella@live.com>2018-10-19 19:27:49 +0200
commit576ada138fc5eed3f58a4aff8141e483310c90fb (patch)
treeed53f8842e909e0cb5777ba6ced4b7412fc82f02 /plugins/colorize
parent951e6494274297050395315501883b7c6b83f3b0 (diff)
downloadzsh-576ada138fc5eed3f58a4aff8141e483310c90fb.tar.gz
zsh-576ada138fc5eed3f58a4aff8141e483310c90fb.tar.bz2
zsh-576ada138fc5eed3f58a4aff8141e483310c90fb.zip
colorize: add README and refactor plugin (#7314)
Diffstat (limited to 'plugins/colorize')
-rw-r--r--plugins/colorize/README.md18
-rw-r--r--plugins/colorize/colorize.plugin.zsh21
2 files changed, 28 insertions, 11 deletions
diff --git a/plugins/colorize/README.md b/plugins/colorize/README.md
new file mode 100644
index 000000000..c006071f9
--- /dev/null
+++ b/plugins/colorize/README.md
@@ -0,0 +1,18 @@
+# colorize
+
+With this plugin you can syntax-highlight file contents of over 300 supported languages and other text formats.
+
+To use it, add colorize to the plugins array of your zshrc file:
+```
+plugins=(... colorize)
+```
+
+## Usage
+
+* `ccat <file> [files]`: colorize the contents of the file (or files, if more than one are provided). If no arguments are passed it will colorize the standard input or stdin.
+
+Colorize will highlight the content based on the filename extension. If it can't find a syntax-highlighting method for a given extension, it will try to find one by looking at the file contents. If no highlight method is found it will just cat the file normally, without syntax highlighting.
+
+## Requirements
+
+You have to install Pygments first: [pygments.org](http://pygments.org/download/)
diff --git a/plugins/colorize/colorize.plugin.zsh b/plugins/colorize/colorize.plugin.zsh
index e2af6d25e..8eede9a94 100644
--- a/plugins/colorize/colorize.plugin.zsh
+++ b/plugins/colorize/colorize.plugin.zsh
@@ -1,9 +1,4 @@
-# Plugin for highlighting file content
-# Plugin highlights file content based on the filename extension.
-# If no highlighting method supported for given extension then it tries
-# guess it by looking for file content.
-
-#easier alias to use plugin
+# easier alias to use the plugin
alias ccat='colorize_via_pygmentize'
colorize_via_pygmentize() {
@@ -12,16 +7,20 @@ colorize_via_pygmentize() {
return 1
fi
+ # pygmentize stdin if no arguments passed
if [ $# -eq 0 ]; then
- pygmentize -g $@
+ pygmentize -g
+ return $?
fi
+ # guess lexer from file extension, or
+ # guess it from file contents if unsuccessful
+ local FNAME lexer
for FNAME in $@
do
- filename=$(basename "$FNAME")
- lexer=`pygmentize -N \"$filename\"`
- if [ "Z$lexer" != "Ztext" ]; then
- pygmentize -l $lexer "$FNAME"
+ lexer=$(pygmentize -N "$FNAME")
+ if [[ $lexer != text ]]; then
+ pygmentize -l "$lexer" "$FNAME"
else
pygmentize -g "$FNAME"
fi